diff --git a/freebsd/sys/kern/vfs_vnops.c b/freebsd/sys/kern/vfs_vnops.c
index bdd6692d..023d387d 100644
--- a/freebsd/sys/kern/vfs_vnops.c
+++ b/freebsd/sys/kern/vfs_vnops.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -45,7 +47,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_hwpmc_hooks.h"
+#include <rtems/bsd/local/opt_hwpmc_hooks.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -74,7 +76,7 @@ __FBSDID("$FreeBSD$");
 #include <sys/ttycom.h>
 #include <sys/conf.h>
 #include <sys/syslog.h>
-#include <sys/unistd.h>
+#include <rtems/bsd/sys/unistd.h>
 #include <sys/user.h>
 
 #include <security/audit/audit.h>
@@ -114,10 +116,14 @@ struct 	fileops vnops = {
 	.fo_close = vn_closefile,
 	.fo_chmod = vn_chmod,
 	.fo_chown = vn_chown,
+#ifndef __rtems__
 	.fo_sendfile = vn_sendfile,
+#endif /* __rtems__ */
 	.fo_seek = vn_seek,
+#ifndef __rtems__
 	.fo_fill_kinfo = vn_fill_kinfo,
 	.fo_mmap = vn_mmap,
+#endif /* __rtems__ */
 	.fo_flags = DFLAG_PASSABLE | DFLAG_SEEKABLE
 };
 
@@ -353,8 +359,10 @@ vn_open_vnode(struct vnode *vp, int fmode, struct ucred *cred,
 	}
 	if (fmode & FREAD)
 		accmode |= VREAD;
+#ifndef __rtems__
 	if (fmode & FEXEC)
 		accmode |= VEXEC;
+#endif /* __rtems__ */
 	if ((fmode & O_APPEND) && (fmode & FWRITE))
 		accmode |= VAPPEND;
 #ifdef MAC
@@ -394,7 +402,9 @@ vn_open_vnode(struct vnode *vp, int fmode, struct ucred *cred,
 	 * Arrange for that by having fdrop() to use vn_closefile().
 	 */
 	if (error != 0) {
+#ifndef __rtems__
 		fp->f_flag |= FOPENFAILED;
+#endif /* __rtems__ */
 		fp->f_vnode = vp;
 		if (fp->f_ops == &badfileops) {
 			fp->f_type = DTYPE_VNODE;
@@ -448,7 +458,11 @@ vn_close1(struct vnode *vp, int flags, struct ucred *file_cred,
 	vn_start_write(vp, &mp, V_WAIT);
 	vn_lock(vp, lock_flags | LK_RETRY);
 	AUDIT_ARG_VNODE1(vp);
+#ifndef __rtems__
 	if ((flags & (FWRITE | FOPENFAILED)) == FWRITE) {
+#else /* __rtems__ */
+	if ((flags & FWRITE) == FWRITE) {
+#endif /* __rtems__ */
 		VOP_ADD_WRITECOUNT_CHECKED(vp, -1);
 		CTR3(KTR_VFS, "%s: vp %p v_writecount decreased to %d",
 		    __func__, vp, vp->v_writecount);
@@ -478,8 +492,10 @@ sequential_heuristic(struct uio *uio, struct file *fp)
 {
 
 	ASSERT_VOP_LOCKED(fp->f_vnode, __func__);
+#ifndef __rtems__
 	if (fp->f_flag & FRDAHEAD)
 		return (fp->f_seqcount << IO_SEQSHIFT);
+#endif /* __rtems__ */
 
 	/*
 	 * Offset 0 is handled specially.  open() sets f_seqcount to 1 so
@@ -752,6 +768,7 @@ foffset_unlock_uio(struct file *fp, struct uio *uio, int flags)
 static int
 get_advice(struct file *fp, struct uio *uio)
 {
+#ifndef __rtems__
 	struct mtx *mtxp;
 	int ret;
 
@@ -767,6 +784,9 @@ get_advice(struct file *fp, struct uio *uio)
 		ret = fp->f_advice->fa_advice;
 	mtx_unlock(mtxp);
 	return (ret);
+#else /* __rtems__ */
+	return (POSIX_FADV_NORMAL);
+#endif /* __rtems__ */
 }
 
 /*
@@ -946,7 +966,9 @@ vn_io_fault_doio(struct vn_io_fault_args *args, struct uio *uio,
 	int error, save;
 
 	error = 0;
+#ifndef __rtems__
 	save = vm_fault_disable_pagefaults();
+#endif /* __rtems__ */
 	switch (args->kind) {
 	case VN_IO_FAULT_FOP:
 		error = (args->args.fop_args.doio)(args->args.fop_args.fp,
@@ -965,24 +987,31 @@ vn_io_fault_doio(struct vn_io_fault_args *args, struct uio *uio,
 		panic("vn_io_fault_doio: unknown kind of io %d %d",
 		    args->kind, uio->uio_rw);
 	}
+#ifndef __rtems__
 	vm_fault_enable_pagefaults(save);
+#endif /* __rtems__ */
 	return (error);
 }
 
 static int
 vn_io_fault_touch(char *base, const struct uio *uio)
 {
+#ifndef __rtems__
 	int r;
 
 	r = fubyte(base);
 	if (r == -1 || (uio->uio_rw == UIO_READ && subyte(base, r) == -1))
 		return (EFAULT);
 	return (0);
+#else /* __rtems__ */
+	return (EFAULT);
+#endif /* __rtems__ */
 }
 
 static int
 vn_io_fault_prefault_user(const struct uio *uio)
 {
+#ifndef __rtems__
 	char *base;
 	const struct iovec *iov;
 	size_t len;
@@ -1020,6 +1049,9 @@ vn_io_fault_prefault_user(const struct uio *uio)
 		}
 	}
 	return (error);
+#else /* __rtems__ */
+	return (EFAULT);
+#endif /* __rtems__ */
 }
 
 /*
@@ -1042,6 +1074,9 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 	size_t len, resid;
 	ssize_t adv;
 	int error, cnt, saveheld, prev_td_ma_cnt;
+#ifdef __rtems__
+	struct uio uio_clone_;
+#endif /* __rtems__ */
 
 	if (vn_io_fault_prefault) {
 		error = vn_io_fault_prefault_user(uio);
@@ -1060,7 +1095,12 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 	 * Cache a copy of the original uio, which is advanced to the redo
 	 * point using UIO_NOCOPY below.
 	 */
+#ifndef __rtems__
 	uio_clone = cloneuio(uio);
+#else /* __rtems__ */
+	uio_clone_ = *uio;
+	uio_clone = &uio_clone_;
+#endif /* __rtems__ */
 	resid = uio->uio_resid;
 
 	short_uio.uio_segflg = UIO_USERSPACE;
@@ -1076,9 +1116,11 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 	uiomove(NULL, resid - uio->uio_resid, uio_clone);
 	uio_clone->uio_segflg = uio->uio_segflg;
 
+#ifndef __rtems__
 	saveheld = curthread_pflags_set(TDP_UIOHELD);
 	prev_td_ma = td->td_ma;
 	prev_td_ma_cnt = td->td_ma_cnt;
+#endif /* __rtems__ */
 
 	while (uio_clone->uio_resid != 0) {
 		len = uio_clone->uio_iov->iov_len;
@@ -1098,6 +1140,7 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 			break;
 		}
 		cnt = atop(end - trunc_page(addr));
+#ifndef __rtems__
 		/*
 		 * A perfectly misaligned address and length could cause
 		 * both the start and the end of the chunk to use partial
@@ -1109,16 +1152,21 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 			error = EFAULT;
 			break;
 		}
+#endif /* __rtems__ */
 		short_uio.uio_iov = &short_iovec[0];
 		short_iovec[0].iov_base = (void *)addr;
 		short_uio.uio_iovcnt = 1;
 		short_uio.uio_resid = short_iovec[0].iov_len = len;
 		short_uio.uio_offset = uio_clone->uio_offset;
+#ifndef __rtems__
 		td->td_ma = ma;
 		td->td_ma_cnt = cnt;
+#endif /* __rtems__ */
 
 		error = vn_io_fault_doio(args, &short_uio, td);
+#ifndef __rtems__
 		vm_page_unhold_pages(ma, cnt);
+#endif /* __rtems__ */
 		adv = len - short_uio.uio_resid;
 
 		uio_clone->uio_iov->iov_base =
@@ -1133,11 +1181,15 @@ vn_io_fault1(struct vnode *vp, struct uio *uio, struct vn_io_fault_args *args,
 		if (error != 0 || adv == 0)
 			break;
 	}
+#ifndef __rtems__
 	td->td_ma = prev_td_ma;
 	td->td_ma_cnt = prev_td_ma_cnt;
 	curthread_pflags_restore(saveheld);
+#endif /* __rtems__ */
 out:
+#ifndef __rtems__
 	free(uio_clone, M_IOV);
+#endif /* __rtems__ */
 	return (error);
 }
 
@@ -1145,6 +1197,7 @@ static int
 vn_io_fault(struct file *fp, struct uio *uio, struct ucred *active_cred,
     int flags, struct thread *td)
 {
+#ifdef __rtems__
 	fo_rdwr_t *doio;
 	struct vnode *vp;
 	void *rl_cookie;
@@ -1178,6 +1231,9 @@ vn_io_fault(struct file *fp, struct uio *uio, struct ucred *active_cred,
 	}
 	foffset_unlock_uio(fp, uio, flags);
 	return (error);
+#else /* __rtems__ */
+	return (EFAULT);
+#endif /* __rtems__ */
 }
 
 /*
@@ -1195,6 +1251,8 @@ vn_io_fault(struct file *fp, struct uio *uio, struct ucred *active_cred,
 int
 vn_io_fault_uiomove(char *data, int xfersize, struct uio *uio)
 {
+#ifndef __rtems__
+	return (EFAULT);
 	struct uio transp_uio;
 	struct iovec transp_iov[1];
 	struct thread *td;
@@ -1204,8 +1262,10 @@ vn_io_fault_uiomove(char *data, int xfersize, struct uio *uio)
 	td = curthread;
 	if ((td->td_pflags & TDP_UIOHELD) == 0 ||
 	    uio->uio_segflg != UIO_USERSPACE)
+#endif /* __rtems__ */
 		return (uiomove(data, xfersize, uio));
 
+#ifndef __rtems__
 	KASSERT(uio->uio_iovcnt == 1, ("uio_iovcnt %d", uio->uio_iovcnt));
 	transp_iov[0].iov_base = data;
 	transp_uio.uio_iov = &transp_iov[0];
@@ -1246,12 +1306,14 @@ vn_io_fault_uiomove(char *data, int xfersize, struct uio *uio)
 	uio->uio_resid -= adv;
 	uio->uio_offset += adv;
 	return (error);
+#endif /* __rtems__ */
 }
 
 int
 vn_io_fault_pgmove(vm_page_t ma[], vm_offset_t offset, int xfersize,
     struct uio *uio)
 {
+#ifndef __rtems__
 	struct thread *td;
 	vm_offset_t iov_base;
 	int cnt, pgadv;
@@ -1284,6 +1346,9 @@ vn_io_fault_pgmove(vm_page_t ma[], vm_offset_t offset, int xfersize,
 	uio->uio_resid -= cnt;
 	uio->uio_offset += cnt;
 	return (0);
+#else /* __rtems__ */
+	return (EFAULT);
+#endif /* __rtems__ */
 }
 
 
@@ -1440,7 +1505,9 @@ vn_stat(struct vnode *vp, struct stat *sb, struct ucred *active_cred,
 	sb->st_atim = vap->va_atime;
 	sb->st_mtim = vap->va_mtime;
 	sb->st_ctim = vap->va_ctime;
+#ifndef __rtems__
 	sb->st_birthtim = vap->va_birthtime;
+#endif /* __rtems__ */
 
         /*
 	 * According to www.opengroup.org, the meaning of st_blksize is 
@@ -1452,11 +1519,13 @@ vn_stat(struct vnode *vp, struct stat *sb, struct ucred *active_cred,
 
 	sb->st_blksize = max(PAGE_SIZE, vap->va_blocksize);
 	
+#ifndef __rtems__
 	sb->st_flags = vap->va_flags;
 	if (priv_check(td, PRIV_VFS_GENERATION))
 		sb->st_gen = 0;
 	else
 		sb->st_gen = vap->va_gen;
+#endif /* __rtems__ */
 
 	sb->st_blocks = vap->va_bytes / S_BLKSIZE;
 	return (0);
@@ -1486,6 +1555,7 @@ vn_ioctl(struct file *fp, u_long com, void *data, struct ucred *active_cred,
 			if (error == 0)
 				*(int *)data = vattr.va_size - fp->f_offset;
 			return (error);
+#ifndef __rtems__
 		case FIOBMAP2:
 			bmarg = (struct fiobmap2_arg *)data;
 			vn_lock(vp, LK_SHARED | LK_RETRY);
@@ -1498,6 +1568,7 @@ vn_ioctl(struct file *fp, u_long com, void *data, struct ucred *active_cred,
 				    &bmarg->bn, &bmarg->runp, &bmarg->runb);
 			VOP_UNLOCK(vp, 0);
 			return (error);
+#endif /* __rtems__ */
 		case FIONBIO:
 		case FIOASYNC:
 			return (0);
@@ -1578,7 +1649,11 @@ vn_closefile(struct file *fp, struct thread *td)
 
 	vp = fp->f_vnode;
 	fp->f_ops = &badfileops;
+#ifndef __rtems__
 	ref= (fp->f_flag & FHASLOCK) != 0 && fp->f_type == DTYPE_VNODE;
+#else /* __rtems__ */
+	ref = false;
+#endif /* __rtems__ */
 
 	error = vn_close1(vp, fp->f_flag, fp->f_cred, td, ref);
 
@@ -1617,7 +1692,11 @@ vn_start_write_locked(struct mount *mp, int flags)
 	/*
 	 * Check on status of suspension.
 	 */
+#ifndef __rtems__
 	if ((curthread->td_pflags & TDP_IGNSUSP) == 0 ||
+#else /* __rtems__ */
+	if (
+#endif /* __rtems__ */
 	    mp->mnt_susp_owner != curthread) {
 		mflags = ((mp->mnt_vfc->vfc_flags & VFCF_SBDRY) != 0 ?
 		    (flags & PCATCH) : 0) | (PUSER - 1);
@@ -1864,7 +1943,9 @@ vfs_write_resume(struct mount *mp, int flags)
 		mp->mnt_susp_owner = NULL;
 		wakeup(&mp->mnt_writeopcount);
 		wakeup(&mp->mnt_flag);
+#ifndef __rtems__
 		curthread->td_pflags &= ~TDP_IGNSUSP;
+#endif /* __rtems__ */
 		if ((flags & VR_START_WRITE) != 0) {
 			MNT_REF(mp);
 			mp->mnt_writeopcount++;
@@ -1910,7 +1991,9 @@ vfs_write_suspend_umnt(struct mount *mp)
 	mp->mnt_kern_flag &= ~(MNTK_SUSPENDED | MNTK_SUSPEND2);
 	wakeup(&mp->mnt_flag);
 	MNT_IUNLOCK(mp);
+#ifndef __rtems__
 	curthread->td_pflags |= TDP_IGNSUSP;
+#endif /* __rtems__ */
 	return (0);
 }
 
@@ -2106,9 +2189,11 @@ vn_rlimit_fsize(const struct vnode *vp, const struct uio *uio,
 		return (0);
 	if ((uoff_t)uio->uio_offset + uio->uio_resid >
 	    lim_cur(td, RLIMIT_FSIZE)) {
+#ifndef __rtems__
 		PROC_LOCK(td->td_proc);
 		kern_psignal(td->td_proc, SIGXFSZ);
 		PROC_UNLOCK(td->td_proc);
+#endif /* __rtems__ */
 		return (EFBIG);
 	}
 	return (0);
@@ -2147,6 +2232,7 @@ vn_chown(struct file *fp, uid_t uid, gid_t gid, struct ucred *active_cred,
 void
 vn_pages_remove(struct vnode *vp, vm_pindex_t start, vm_pindex_t end)
 {
+#ifndef __rtems__
 	vm_object_t object;
 
 	if ((object = vp->v_object) == NULL)
@@ -2154,6 +2240,7 @@ vn_pages_remove(struct vnode *vp, vm_pindex_t start, vm_pindex_t end)
 	VM_OBJECT_WLOCK(object);
 	vm_object_page_remove(object, start, end, 0);
 	VM_OBJECT_WUNLOCK(object);
+#endif /* __rtems__ */
 }
 
 int
@@ -2386,6 +2473,7 @@ vn_fill_kinfo_vnode(struct vnode *vp, struct kinfo_file *kif)
 	return (0);
 }
 
+#ifndef __rtems__
 int
 vn_mmap(struct file *fp, vm_map_t map, vm_offset_t *addr, vm_size_t size,
     vm_prot_t prot, vm_prot_t cap_maxprot, int flags, vm_ooffset_t foff,
@@ -2499,6 +2587,7 @@ vn_mmap(struct file *fp, vm_map_t map, vm_offset_t *addr, vm_size_t size,
 #endif
 	return (error);
 }
+#endif /* __rtems__ */
 
 void
 vn_fsid(struct vnode *vp, struct vattr *va)
diff --git a/freebsd/sys/net/route.c b/freebsd/sys/net/route.c
index adbf91bd..2e9883a1 100644
--- a/freebsd/sys/net/route.c
+++ b/freebsd/sys/net/route.c
@@ -407,9 +407,6 @@ struct setfib_args {
 	int     fibnum;
 };
 #endif
-#ifdef __rtems__
-static
-#endif /* __rtems__ */
 int
 sys_setfib(struct thread *td, struct setfib_args *uap)
 {
@@ -423,20 +420,6 @@ sys_setfib(struct thread *td, struct setfib_args *uap)
 #endif /* __rtems__ */
 	return (0);
 }
-#ifdef __rtems__
-int
-setfib(int fibnum)
-{
-	struct setfib_args ua = {
-		.fibnum = fibnum
-	};
-	int error;
-
-	error = sys_setfib(NULL, &ua);
-
-	return rtems_bsd_error_to_status_and_errno(error);
-}
-#endif /* __rtems__ */
 
 /*
  * Packet routing routines.
@@ -2302,4 +2285,3 @@ rt_newaddrmsg_fib(int cmd, struct ifaddr *ifa, int error, struct rtentry *rt,
 		rt_addrmsg(cmd, ifa, fibnum);
 	}
 }
-
diff --git a/freebsd/sys/opencrypto/cryptodev.c b/freebsd/sys/opencrypto/cryptodev.c
index d3f4ad1c..71872532 100644
--- a/freebsd/sys/opencrypto/cryptodev.c
+++ b/freebsd/sys/opencrypto/cryptodev.c
@@ -303,8 +303,6 @@ SYSCTL_TIMEVAL_SEC(_kern, OID_AUTO, cryptodev_warn_interval, CTLFLAG_RW,
     &warninterval,
     "Delay in seconds between warnings of deprecated /dev/crypto algorithms");
 
-#ifndef __rtems__
->>>>>>> e79fbf70f7e... RTEMS
 static	int cryptof_ioctl(struct file *, u_long, void *,
 		    struct ucred *, struct thread *);
 static	int cryptof_stat(struct file *, struct stat *,
@@ -327,9 +325,6 @@ static struct fileops cryptofops = {
     .fo_sendfile = invfo_sendfile,
     .fo_fill_kinfo = cryptof_fill_kinfo,
 };
-#else /* __rtems__ */
-static const rtems_filesystem_file_handlers_r cryptofops;
-#endif /* __rtems__ */
 
 static struct csession *csefind(struct fcrypt *, u_int);
 static bool csedelete(struct fcrypt *, u_int);
@@ -773,27 +768,6 @@ bail:
 	return (error);
 #undef SES2
 }
-#ifdef __rtems__
-static int
-rtems_bsd_cryptof_ioctl(rtems_libio_t *iop, ioctl_command_t request,
-    void *buffer)
-{
-	struct thread *td;
-	int error;
-
-	td = rtems_bsd_get_curthread_or_null();
-	if (td != NULL) {
-		struct file *fp;
-
-		fp = rtems_bsd_iop_to_fp(iop);
-		error = cryptof_ioctl(fp, request, buffer, NULL, td);
-	} else {
-		error = ENOMEM;
-	}
-
-	return (rtems_bsd_error_to_status_and_errno(error));
-}
-#endif /* __rtems__ */
 
 static int cryptodev_cb(struct cryptop *);
 
@@ -1384,17 +1358,11 @@ cryptodev_find(struct crypt_find_op *find)
 
 /* ARGSUSED */
 static int
-#ifndef __rtems__
 cryptof_stat(
 	struct file *fp,
 	struct stat *sb,
 	struct ucred *active_cred,
 	struct thread *td)
-#else /* __rtems__ */
-rtems_bsd_cryptof_stat(const rtems_filesystem_location_info_t *loc,
-    struct stat *buf
-#endif /* __rtems__ */
-)
 {
 
 	return (EOPNOTSUPP);
@@ -1418,28 +1386,7 @@ cryptof_close(struct file *fp, struct thread *td)
 	fp->f_data = NULL;
 	return 0;
 }
-#ifdef __rtems__
-static int
-rtems_bsd_cryptof_close(rtems_libio_t *iop)
-{
-	struct thread *td;
-	int error;
-
-	td = rtems_bsd_get_curthread_or_null();
-	if (td != NULL) {
-		struct file *fp;
 
-		fp = rtems_bsd_iop_to_fp(iop);
-		error = cryptof_close(fp, td);
-	} else {
-		error = ENOMEM;
-	}
-
-	return (rtems_bsd_error_to_status_and_errno(error));
-}
-#endif /* __rtems__ */
-
-#ifndef __rtems__
 static int
 cryptof_fill_kinfo(struct file *fp, struct kinfo_file *kif, struct filedesc *fdp)
 {
@@ -1447,7 +1394,6 @@ cryptof_fill_kinfo(struct file *fp, struct kinfo_file *kif, struct filedesc *fdp
 	kif->kf_type = KF_TYPE_CRYPTO;
 	return (0);
 }
-#endif /* __rtems__ */
 
 static struct csession *
 csefind(struct fcrypt *fcr, u_int ses)
@@ -1567,10 +1513,17 @@ cryptoioctl(struct cdev *dev, u_long cmd, caddr_t data, int flag, struct thread
 		}
 		/* falloc automatically provides an extra reference to 'f'. */
 		finit(f, FREAD | FWRITE, DTYPE_CRYPTO, fcr, &cryptofops);
+#ifdef __rtems__
+		fd = rtems_bsd_libio_iop_allocate_with_file(td, fd, &rtems_bsd_sysgen_nodeops);
+		if (fd < 0) {
+			fdclose(td, f, fd);
+			mtx_destroy(&fcr->lock);
+			free(fcr, M_XDATA);
+			return (error);
+		}
+#endif /* __rtems__ */
 		*(u_int32_t *)data = fd;
-#ifndef __rtems__
 		fdrop(f, td);
-#endif /* __rtems__ */
 		break;
 	case CRIOFINDDEV:
 		error = cryptodev_find((struct crypt_find_op *)data);
@@ -1627,23 +1580,3 @@ MODULE_VERSION(cryptodev, 1);
 DECLARE_MODULE(cryptodev, cryptodev_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
 MODULE_DEPEND(cryptodev, crypto, 1, 1, 1);
 MODULE_DEPEND(cryptodev, zlib, 1, 1, 1);
-#ifdef __rtems__
-static const rtems_filesystem_file_handlers_r cryptofops = {
-	.open_h = rtems_filesystem_default_open,
-	.close_h = rtems_bsd_cryptof_close,
-	.read_h = rtems_filesystem_default_read,
-	.write_h = rtems_filesystem_default_write,
-	.ioctl_h = rtems_bsd_cryptof_ioctl,
-	.lseek_h = rtems_filesystem_default_lseek,
-	.fstat_h = rtems_bsd_cryptof_stat,
-	.ftruncate_h = rtems_filesystem_default_ftruncate,
-	.fsync_h = rtems_filesystem_default_fsync_or_fdatasync,
-	.fdatasync_h = rtems_filesystem_default_fsync_or_fdatasync,
-	.fcntl_h = rtems_filesystem_default_fcntl,
-	.poll_h = rtems_filesystem_default_poll,
-	.kqfilter_h = rtems_filesystem_default_kqfilter,
-	.readv_h = rtems_filesystem_default_readv,
-	.writev_h = rtems_filesystem_default_writev,
-	.mmap_h = rtems_filesystem_default_mmap
-};
-#endif /* __rtems__ */
diff --git a/freebsd/sys/sys/bio.h b/freebsd/sys/sys/bio.h
index 1dab6155..b361437f 100644
--- a/freebsd/sys/sys/bio.h
+++ b/freebsd/sys/sys/bio.h
@@ -102,9 +102,11 @@ struct bio {
 	void	*bio_caller2;		/* Private use by the consumer. */
 	TAILQ_ENTRY(bio) bio_queue;	/* Disksort queue. */
 	const char *bio_attribute;	/* Attribute for BIO_[GS]ETATTR */
+#ifndef __rtems__
 	struct  disk_zone_args bio_zone;/* Used for BIO_ZONE */
 	struct g_consumer *bio_from;	/* GEOM linkage */
 	struct g_provider *bio_to;	/* GEOM linkage */
+#endif /* __rtems__ */
 	off_t	bio_length;		/* Like bio_bcount */
 	off_t	bio_completed;		/* Inverse of bio_resid */
 	u_int	bio_children;		/* Number of spawned bios */
diff --git a/freebsd/sys/sys/capsicum.h b/freebsd/sys/sys/capsicum.h
index ee5e4267..9fcd3cc1 100644
--- a/freebsd/sys/sys/capsicum.h
+++ b/freebsd/sys/sys/capsicum.h
@@ -336,9 +336,9 @@ cap_rights_t *__cap_rights_set(cap_rights_t *rights, ...);
 	__cap_rights_clear(__VA_ARGS__, 0ULL)
 cap_rights_t *__cap_rights_clear(cap_rights_t *rights, ...);
 #else /* __rtems__ */
-#define	cap_rights_init(...) (void)0
-#define	cap_rights_set(...) (void)0
-#define	cap_rights_clear(...) (void)0
+#define	cap_rights_init(...) NULL
+#define	cap_rights_set(...) NULL
+#define	cap_rights_clear(...) NULL
 #endif /* __rtems__ */
 
 #define	cap_rights_is_set(...)						\
diff --git a/freebsd/sys/sys/conf.h b/freebsd/sys/sys/conf.h
index d6215ba9..556b3f2e 100644
--- a/freebsd/sys/sys/conf.h
+++ b/freebsd/sys/sys/conf.h
@@ -90,15 +90,11 @@ struct cdev {
 	LIST_HEAD(, cdev)	si_children;
 	LIST_ENTRY(cdev)	si_siblings;
 	struct cdev *si_parent;
-#ifndef __rtems__
 	struct mount	*si_mountpt;
-#endif /* __rtems__ */
 	void		*si_drv1, *si_drv2;
 	struct cdevsw	*si_devsw;
-#ifndef __rtems__
 	int		si_iosize_max;	/* maximum I/O size (for physio &al) */
 	u_long		si_usecount;
-#endif /* __rtems__ */
 	u_long		si_threadcount;
 #ifndef __rtems__
 	union {
diff --git a/freebsd/sys/sys/eventvar.h b/freebsd/sys/sys/eventvar.h
index 8afaa1aa..1ed6e9fc 100644
--- a/freebsd/sys/sys/eventvar.h
+++ b/freebsd/sys/sys/eventvar.h
@@ -48,9 +48,7 @@ struct kqueue {
 	int		kq_count;		/* number of pending events */
 	struct		selinfo kq_sel;
 	struct		sigio *kq_sigio;
-#ifndef __rtems__
 	struct		filedesc *kq_fdp;
-#endif /* __rtems__ */
 	int		kq_state;
 #define KQ_SEL		0x01
 #define KQ_SLEEP	0x02
diff --git a/freebsd/sys/sys/file.h b/freebsd/sys/sys/file.h
index 0e7c296a..d48ca0e9 100644
--- a/freebsd/sys/sys/file.h
+++ b/freebsd/sys/sys/file.h
@@ -172,7 +172,6 @@ struct fadvise_info {
 };
 
 struct file {
-#ifndef __rtems__
 	void		*f_data;	/* file descriptor specific data */
 	struct fileops	*f_ops;		/* File operations */
 	struct ucred	*f_cred;	/* associated credentials. */
@@ -202,93 +201,13 @@ struct file {
 	 * Mandatory Access control information.
 	 */
 	void		*f_label;	/* Place-holder for MAC label. */
-#else /* __rtems__ */
-	rtems_libio_t	f_io;
-#endif /* __rtems__ */
-};
 #ifdef __rtems__
-#define f_data f_io.pathinfo.node_access_2
-#define	f_cdevpriv	f_io.data1
-
-static inline struct file *
-rtems_bsd_iop_to_fp(rtems_libio_t *iop)
-{
-	return (struct file *) iop;
-}
-
-static inline struct file *
-rtems_bsd_fd_to_fp(int fd)
-{
-	return rtems_bsd_iop_to_fp(&rtems_libio_iops[fd]);
-}
-
-static inline int
-rtems_bsd_fp_to_fd(struct file *fp)
-{
-	return fp - rtems_bsd_iop_to_fp(&rtems_libio_iops[0]);
-}
-
-static inline void *
-rtems_bsd_loc_to_f_data(const rtems_filesystem_location_info_t *loc)
-{
-	return loc->node_access_2;
-}
-
-static inline uint32_t
-rtems_bsd_fflag_to_libio_flags(u_int fflag)
-{
-	uint32_t libio_flags = 0;
-
-	if ((fflag & FREAD) == FREAD) {
-		libio_flags |= LIBIO_FLAGS_READ;
-	}
-
-	if ((fflag & FWRITE) == FWRITE) {
-		libio_flags |= LIBIO_FLAGS_WRITE;
-	}
-
-	if ((fflag & FNONBLOCK) == FNONBLOCK) {
-		libio_flags |= LIBIO_FLAGS_NO_DELAY;
-	}
-
-	return (libio_flags);
-}
-
-static inline u_int
-rtems_bsd_libio_flags_to_fflag(uint32_t libio_flags)
-{
-	u_int fflag = 0;
-
-	if ((libio_flags & LIBIO_FLAGS_READ) == LIBIO_FLAGS_READ) {
-		fflag |= FREAD;
-	}
-
-	if ((libio_flags & LIBIO_FLAGS_WRITE) == LIBIO_FLAGS_WRITE) {
-		fflag |= FWRITE;
-	}
-
-	if ((libio_flags & LIBIO_FLAGS_NO_DELAY) == LIBIO_FLAGS_NO_DELAY) {
-		fflag |= FNONBLOCK;
-	}
-
-	return (fflag);
-}
-
-static int inline
-rtems_bsd_error_to_status_and_errno(int error)
-{
-	if (error == 0) {
-		return 0;
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
+	rtems_libio_t	*f_io;
 #endif /* __rtems__ */
+};
 
-#ifndef __rtems__
 #define	f_cdevpriv	f_vnun.fvn_cdevpriv
 #define	f_advice	f_vnun.fvn_advice
-#endif /* __rtems__ */
 
 #define	FOFFSET_LOCKED       0x1
 #define	FOFFSET_LOCK_WAITING 0x2
@@ -323,32 +242,12 @@ struct xfile {
 
 extern struct fileops vnops;
 extern struct fileops badfileops;
-#ifndef __rtems__
 extern struct fileops socketops;
-#else /* __rtems__ */
-extern const rtems_filesystem_file_handlers_r socketops;
-#endif /* __rtems__ */
 extern int maxfiles;		/* kernel limit on number of open files */
 extern int maxfilesperproc;	/* per process limit on number of open files */
 extern volatile int openfiles;	/* actual number of open files */
 
-#ifndef __rtems__
 int fget(struct thread *td, int fd, cap_rights_t *rightsp, struct file **fpp);
-#else /* __rtems__ */
-struct file *rtems_bsd_get_file(int fd);
-
-static inline int
-rtems_bsd_do_fget(int fd, struct file **fpp)
-{
-	struct file *fp;
-
-	fp = rtems_bsd_get_file(fd);
-	*fpp = fp;
-	return (fp != NULL ? 0 : EBADF);
-}
-
-#define	fget(td, fd, rights, fpp)	rtems_bsd_do_fget(fd, fpp)
-#endif /* __rtems__ */
 int fget_mmap(struct thread *td, int fd, cap_rights_t *rightsp,
     u_char *maxprotp, struct file **fpp);
 int fget_read(struct thread *td, int fd, cap_rights_t *rightsp,
@@ -359,7 +258,6 @@ int fget_fcntl(struct thread *td, int fd, cap_rights_t *rightsp,
     int needfcntl, struct file **fpp);
 int _fdrop(struct file *fp, struct thread *td);
 
-#ifndef __rtems__
 fo_rdwr_t	invfo_rdwr;
 fo_truncate_t	invfo_truncate;
 fo_ioctl_t	invfo_ioctl;
@@ -371,27 +269,12 @@ fo_sendfile_t	invfo_sendfile;
 
 fo_sendfile_t	vn_sendfile;
 fo_seek_t	vn_seek;
+#ifndef __rtems__
 fo_fill_kinfo_t	vn_fill_kinfo;
 int vn_fill_kinfo_vnode(struct vnode *vp, struct kinfo_file *kif);
-#else /* __rtems__ */
-int rtems_bsd_soo_kqfilter(rtems_libio_t *iop, struct knote *kn);
 #endif /* __rtems__ */
 
-#ifndef __rtems__
 void finit(struct file *, u_int, short, void *, struct fileops *);
-#else /* __rtems__ */
-static inline void
-finit(struct file *fp, u_int fflag, short type, void *data,
-    const rtems_filesystem_file_handlers_r *ops)
-{
-
-	(void)type;
-	fp->f_data = data;
-	fp->f_io.pathinfo.handlers = ops;
-	rtems_libio_iop_flags_set(&fp->f_io, LIBIO_FLAGS_OPEN |
-	    rtems_bsd_fflag_to_libio_flags(fflag));
-}
-#endif /* __rtems__ */
 int fgetvp(struct thread *td, int fd, cap_rights_t *rightsp,
     struct vnode **vpp);
 int fgetvp_exec(struct thread *td, int fd, cap_rights_t *rightsp,
@@ -410,36 +293,32 @@ _fnoop(void)
 	return (0);
 }
 
-#ifndef __rtems__
 static __inline __result_use_check bool
 fhold(struct file *fp)
 {
 	return (refcount_acquire_checked(&fp->f_count));
 }
-#endif /* __rtems__ */
 
 #ifndef __rtems__
 #define	fdrop(fp, td)							\
 	(refcount_release(&(fp)->f_count) ? _fdrop((fp), (td)) : _fnoop())
 #else /* __rtems__ */
-static inline void
-rtems_bsd_fdrop(struct file *fp)
+static inline int fdrop(struct file *fp, struct thread *td)
 {
-
-	rtems_libio_iop_drop(&fp->f_io);
+	if (fp->f_io != NULL) {
+		if (RTEMS_BSD_DESCRIP_TRACE)
+		  printf("bsd:  fb: fdrop: iop=%p %d (%d) fp=%p (%d) by %p\n",
+			 fp->f_io, fp->f_io->data0, fp->f_io->flags >> 12,
+			 fp, fp->f_count, __builtin_return_address(0));
+		rtems_libio_iop_drop(fp->f_io);
+	} else if (RTEMS_BSD_DESCRIP_TRACE) {
+		printf("bsd:  fb: fdrop: %d %p %d by %p\n",
+		       -1, fp, fp->f_count, __builtin_return_address(0));
+	}
+	return (refcount_release(&(fp)->f_count) ? _fdrop((fp), (td)) : _fnoop());
 }
-
-/*
- * WARNING: fdalloc() and falloc_caps() do not increment the reference count of
- * the file descriptor in contrast to FreeBSD.  We must not call the fdrop()
- * corresponding to a fdalloc() or falloc_caps().  The reason for this is that
- * FreeBSD performs a lazy cleanup once the reference count reaches zero.
- * RTEMS uses the reference count to determine if a cleanup is allowed.
- */
-#define	fdrop(fp, td) rtems_bsd_fdrop(fp)
 #endif /* __rtems__ */
 
-#ifndef __rtems__
 static __inline fo_rdwr_t	fo_read;
 static __inline fo_rdwr_t	fo_write;
 static __inline fo_truncate_t	fo_truncate;
@@ -475,29 +354,13 @@ fo_truncate(struct file *fp, off_t length, struct ucred *active_cred,
 
 	return ((*fp->f_ops->fo_truncate)(fp, length, active_cred, td));
 }
-#endif /* __rtems__ */
 
 static __inline int
 fo_ioctl(struct file *fp, u_long com, void *data, struct ucred *active_cred,
     struct thread *td)
 {
 
-#ifndef __rtems__
 	return ((*fp->f_ops->fo_ioctl)(fp, com, data, active_cred, td));
-#else /* __rtems__ */
-	int rv;
-
-	(void) active_cred;
-	(void) td;
-
-	errno = 0;
-	rv = ((*fp->f_io.pathinfo.handlers->ioctl_h)(&fp->f_io, com, data));
-	if (rv == 0) {
-		return (0);
-	} else {
-		return (errno);
-	}
-#endif /* __rtems__ */
 }
 
 static __inline int
@@ -505,17 +368,9 @@ fo_poll(struct file *fp, int events, struct ucred *active_cred,
     struct thread *td)
 {
 
-#ifndef __rtems__
 	return ((*fp->f_ops->fo_poll)(fp, events, active_cred, td));
-#else /* __rtems__ */
-	(void) active_cred;
-	(void) td;
-
-	return ((*fp->f_io.pathinfo.handlers->poll_h)(&fp->f_io, events));
-#endif /* __rtems__ */
 }
 
-#ifndef __rtems__
 static __inline int
 fo_stat(struct file *fp, struct stat *sb, struct ucred *active_cred,
     struct thread *td)
@@ -530,20 +385,14 @@ fo_close(struct file *fp, struct thread *td)
 
 	return ((*fp->f_ops->fo_close)(fp, td));
 }
-#endif /* __rtems__ */
 
 static __inline int
 fo_kqfilter(struct file *fp, struct knote *kn)
 {
 
-#ifndef __rtems__
 	return ((*fp->f_ops->fo_kqfilter)(fp, kn));
-#else /* __rtems__ */
-	return ((*fp->f_io.pathinfo.handlers->kqfilter_h)(&fp->f_io, kn));
-#endif /* __rtems__ */
 }
 
-#ifndef __rtems__
 static __inline int
 fo_chmod(struct file *fp, mode_t mode, struct ucred *active_cred,
     struct thread *td)
@@ -602,6 +451,9 @@ fo_aio_queue(struct file *fp, struct kaiocb *job)
 
 	return ((*fp->f_ops->fo_aio_queue)(fp, job));
 }
+
+#ifdef __rtems__
+#include <machine/rtems-bsd-libio.h>
 #endif /* __rtems__ */
 
 #endif /* _KERNEL */
